﻿// SelectSentence.jsx

// Скрипт выделяет предложение, в котором стоит курсор.
// Предложение --- это часть абзаца, начинающаяся с прописной буквы и завершающаяся одним из знаков пунктуации:
// точкой, вопросительным знаком, восклицательным знаком, многоточием или точкой с запятой.
// Программа выделяет предложения в тексте, сносках, в ячейках таблицы.
// 

/*
The script highlights the sentence where the cursor is.
Let's agree that a sentence is a part of a paragraph that begins with a capital letter and ends with one of the punctuation marks:
a dot, a question mark, an exclamation mark, an ellipsis, or a semicolon.
The program highlights sentences in the text, footnotes, and table cells.
*/

// © Mikhail Ivanyushin 2021.  dotextok@gmail.com  |  https://shop.dotextok.ru/en/   |    https://dotextok.ru

/*
var mes1 = "Выделение предложения";
var mes2 = "Нет открытых документов.";
var mes3 = "Курсор должен быть в предложении, которое надо выделить."; 
var mes4 = "Ничего не найдено";
*/

var mes1 = "Sentence Selection";
var mes2 = "No opened files";
var mes3 = "The cursor should be in the sentence to be highlighted"; 
var mes4 = "Nothing found";

var debug = false;
var programTitul =  mes1;
 if (app.documents.length == 0) {
    alert(mes2,programTitul);
    exit();
    }
var sel = app.selection[0];
if (sel == null || sel.constructor.name != "InsertionPoint") {
    alert(mes3,programTitul);
    exit();
    }
var story = sel.parent; // parent более информативен, чем parentStory, с ним можно отличить, где курсор -- в основном тексте или в сноске, а с parentStory результат будет всегда один --- story
if (story.characters.length == 0) {
    alert(mes4 + " [3]",programTitul); // нет данных, например, пустая ячйка таблицы.
    exit();     
    }
var parentName = story.constructor.name;
var para = sel.paragraphs[0];
var selIndex = sel.index;
app.findGrepPreferences = NothingEnum.nothing;
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = "\\u(?!~F)(.|\\n)+?[.~e!;\?]"; 
var foundSamples = para.findGrep();
if (debug) $.writeln("foundSamples = " + foundSamples.length);
if (foundSamples.length == 0) {
    alert(mes4 + " [1]",programTitul); // с этим запросом поиска ничего не найдено
    exit();    
    }
for (var f = 0; f < foundSamples.length; f++) { // f++    
    if (debug) $.writeln(f + " | " + foundSamples[f].contents + " | " + foundSamples[f].parent.constructor.name);
    if (foundSamples[f].parent.constructor.name != parentName) break;
    if (foundSamples[f].index < selIndex) continue;
    break;
    } // f++
f--;
if (debug) $.writeln(">>  " + f  + " | " + foundSamples[f].contents);
if (f == -1) {
    alert(mes4 + " [2]",programTitul); // курсор в начале абзаца, например, до или после знака сноски, или перед первым предложением абзаца
    exit();    
    }
foundSamples[f].select();
exit();

